TextHUDParty_UpdateRate = 0.066;

function TextHUDParty_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	if (self.TimeSinceLastUpdate > TextHUDParty_UpdateRate) then
		TextHUDParty_UpdateAll();
		self.TimeSinceLastUpdate = 0;
	end
end

function TextHUDParty_UpdateAll()
	TextHUDParty_NameTextUpdate();
	TextHUDParty_HealthTextUpdate();
	TextHUDParty_ManaTextUpdate();
end

function TextHUDParty_NameTextUpdate()
	for i=1, 4 do
		if UnitExists("party"..i) then
			getglobal("TextHUDParty_Party"..i.."NameText"):SetText(UnitName("party"..i));
			local playerClass, englishClass = UnitClass("party"..i);
			if englishClass ~= nil then
				getglobal("TextHUDParty_Party"..i.."NameText"):SetTextColor(RAID_CLASS_COLORS[englishClass].r, RAID_CLASS_COLORS[englishClass].g, RAID_CLASS_COLORS[englishClass].b);
			end
		else
			getglobal("TextHUDParty_Party"..i.."NameText"):SetText("");
		end
	end
end

function TextHUDParty_HealthTextUpdate()
	for i=1, 4 do
		if UnitExists("party"..i) then
			if UnitHealthMax("party"..i) == 1 then
				getglobal("TextHUDParty_Party"..i.."HealthText"):SetText("-");
				getglobal("TextHUDParty_Party"..i.."HealthText"):SetTextColor(0.7, 0.7, 0.7);
			else
				local j = UnitHealth("party"..i) / UnitHealthMax("party"..i) * 100;
				getglobal("TextHUDParty_Party"..i.."HealthText"):SetText(string.format("%4.0f", j));
				local healthColor = TextHUD_SetHealthColor(j);
				getglobal("TextHUDParty_Party"..i.."HealthText"):SetTextColor(healthColor.r, healthColor.g, healthColor.b);
			end
		else
			getglobal("TextHUDParty_Party"..i.."HealthText"):SetText("");
		end
	end
end

function TextHUDParty_ManaTextUpdate()
	for i=1, 4 do
		if UnitExists("party"..i) then
			if UnitPowerMax("party"..i) == 1 then
				getglobal("TextHUDParty_Party"..i.."ManaText"):SetText("-");
				getglobal("TextHUDParty_Party"..i.."ManaText"):SetTextColor(0.7, 0.7, 0.7);
			else
				local j = UnitPower("party"..i) / UnitPowerMax("party"..i) * 100;
				local power = UnitPowerType("party"..i);
				if power == 0 then -- Mana
					getglobal("TextHUDParty_Party"..i.."ManaText"):SetText(string.format("%4.0f", j));
				elseif power == 17 or power == 18 then -- Fury or Pain
					TextHUDTarget_TargetManaText:SetText(UnitPower("player", power));
				else -- Rage/Focus/Energy/Rune Power
					getglobal("TextHUDParty_Party"..i.."ManaText"):SetText(UnitPower("party"..i));
				end
				local manaColor = TextHUD_SetManaColor(j);
				getglobal("TextHUDParty_Party"..i.."ManaText"):SetTextColor(manaColor.r, manaColor.g, manaColor.b);
			end
		else
			getglobal("TextHUDParty_Party"..i.."ManaText"):SetText("");
		end
	end
end