TextHUDTarget_UpdateRate = 0.066;

function TextHUDTarget_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	if (self.TimeSinceLastUpdate > TextHUDTarget_UpdateRate) then
		TextHUDTarget_UpdateAll();
		self.TimeSinceLastUpdate = 0;
	end
end

function TextHUDTarget_UpdateAll()
	TextHUDTarget_NameTextUpdate();
	TextHUDTarget_HealthTextUpdate();
	TextHUDTarget_ManaTextUpdate();
end

function TextHUDTarget_NameTextUpdate()
	if UnitExists("target") then
		TextHUDTarget_TargetNameText:SetText(UnitName("target"));
		local playerClass, englishClass = UnitClass("target");
		if englishClass ~= nil then
			TextHUDTarget_TargetNameText:SetTextColor(RAID_CLASS_COLORS[englishClass].r, RAID_CLASS_COLORS[englishClass].g, RAID_CLASS_COLORS[englishClass].b);
		end
	else
		TextHUDTarget_TargetNameText:SetText("");
	end
end

function TextHUDTarget_HealthTextUpdate()
	if UnitExists("target") then
		if UnitHealthMax("target") == 1 then
			TextHUDTarget_TargetHealthText:SetText("-");
			TextHUDTarget_TargetHealthText:SetTextColor(0.7, 0.7, 0.7);
		else
			local j = UnitHealth("target") / UnitHealthMax("target") * 100;
			TextHUDTarget_TargetHealthText:SetText(string.format("%4.1f", j));
			local healthColor = TextHUD_SetHealthColor(j);
			TextHUDTarget_TargetHealthText:SetTextColor(healthColor.r, healthColor.g, healthColor.b);
		end
	else
		TextHUDTarget_TargetHealthText:SetText("");
	end
end

function TextHUDTarget_ManaTextUpdate()
	if UnitExists("target") then
		if UnitHealthMax("target") == 1 then
			TextHUDTarget_TargetManaText:SetText("-");
			TextHUDTarget_TargetManaText:SetTextColor(0.7, 0.7, 0.7);
		else
			local power = UnitPowerType("target");
			if power == 0 then -- Mana
				TextHUDTarget_TargetManaText:SetText(string.format("%4.0f", UnitPower("target") / UnitPowerMax("target") * 100));
			else
				TextHUDTarget_TargetManaText:SetText(UnitPower("target"));
			end
			local manaColor = TextHUD_SetManaColor(UnitPower("target") / UnitPowerMax("target") * 100);
			TextHUDTarget_TargetManaText:SetTextColor(manaColor.r, manaColor.g, manaColor.b);
		end
	else
		TextHUDTarget_TargetManaText:SetText("");
	end
end